/*
	$Id: ToplevelCompoundImpl.java 172 2006-04-08 22:00:11Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ȥåץ٥륳ѥɤμǤ
*/
public abstract class ToplevelCompoundImpl extends CompoundImpl
    implements ToplevelCompound {

    /** ι¤Τޤ϶Τޤ󷿤̾ */
    private String as;

    /**
       ȥåץ٥륳ѥɤޤ

       @param gm 롼ץޥ͡
       @param label "struct" ޤ "union" ޤ "enum"
       @param elem structǤޤunionǤޤenum
       @param name name°
       @param as alias°͡typedef̾
    */
    protected ToplevelCompoundImpl(final GroupManager gm, final String label,
				   final Element elem, final String name,
				   final String as) {
	super(gm, label, elem, name,
	      (!as.equals("")) ? as : label + " " + name);
	this.as = as;
    }

    @Override protected String getFieldName(final IDManager m) {
	if (as.equals("")) {
	    return super.getFieldName(m);
	}
	return "<b>" + m.getString(as) + "</b> ("
	    + m.getString(name.equals("") ? label : label + " " + name)
	    + ")";
    }

    @Override protected String getFieldName() {
	if (as.equals("")) {
	    return super.getFieldName();
	}
	return "<b>" + as + "</b> ("
	    + (name.equals("") ? label : label + " " + name)
	    + ")";
    }

    @Override protected String getTexFieldName() {
	if (as.equals("")) {
	    return super.getTexFieldName();
	}
	return as + " ("
	    + (name.equals("") ? label : label + " " + name)
	    + ")";
    }

    public void printCode(final PrintWriter wr) {
	String indent = "    ";
	String pre = "", post = "";
	if (!as.equals("")) {
	    pre = "typedef " + label;
	    if (!name.equals("")) {
		pre += " " + name;
	    }
	    pre += " {";
	    post = "} " + as + ";";
	} else {
	    pre = label + " " + name + " {";
	    post = "};";
	}
	wr.println(pre);
	components.printCode(wr, indent);
	wr.println(post);
    }
}
